<?php
if (!defined('PmWiki')) exit();

###########################################################
###
### Block different Crawler from access your site
### Made by: Daniel Scheibler <pmwiki@scheiby.de>
### http://www.scheiby.de
###
### To use this action you have to insert the following line
### into your config.php file
###
### include_once("cookbook/block_crawler.php");
###
### -------------------------------------------------------
###
### add a page BlockCrawler.HomePage to your wiki and
### insert for each Crawler to block a line
### * [Crawlername] -> [Resultpage]
### for example:
### * Googlebot -> Google
###
### This script will result the page BlockCrawler.Google
### to the Google crawler.
###
###########################################################



SDV($BlockCrawlerGroup, 'BlockCrawler');
SDV($BlockCrawlerConfigPage, 'HomePage');
SDV($BlockCrawlerConfigItemize, false);

function f_BlockCrawler()
{
  global $BlockCrawlerGroup;
  global $BlockCrawlerConfigPage;
  global $BlockCrawlerConfigItemize;
  global $pagename;

  $group = FmtPageName('$Group', $pagename);

  if (strcmp($group, $BlockCrawlerGroup) != 0) {
    $useragent = $_SERVER['HTTP_USER_AGENT'];

    $config = ReadPage($BlockCrawlerGroup . "." . $BlockCrawlerConfigPage);
    $arrConfig = $config[text];

    if ($BlockCrawlerConfigItemize) {
      $arrConfig = explode("\n* ", $arrConfig);
      $arrConfig[0] = substr($arrConfig[0], 2, strlen($arrConfig[0])-2);
    } else {
      $arrConfig = explode("\n", $arrConfig);
    }

    $haystack = strtolower($useragent);
    foreach ($arrConfig as $line) {
      $arrLine = explode(" -> ", $line);
      if (!(strpos($haystack, strtolower($arrLine[0])) === false)) {
        header("HTTP/1.0 404 Not Found");
        Redirect($BlockCrawlerGroup . "/" . $arrLine[1]);
        exit;
      } // if useragent
    } // foreach line
  }
}

// Add (:blockcrawler:) markup that will be enable the crawler block
Markup("BlockCrawler", "_begin", "/\\(:blockcrawler:\\)/", "f_BlockCrawler");
